import tabelib
import os.path
import sys
from Splitter import Splitter as BaseSplitter
from ExtensionClass import Base
from string import split, join, lower
import thread
import array
#import perl

csplitter_lock=thread.allocate_lock()

class Splitter(Base, BaseSplitter):
    """ First try at a Chinese-capable Splitter. """

    # default for older objects
    stop_syn={}

    def __init__(self, doc, stop_syn=None, encoding='latin1'):
        mod_dir = os.path.split(sys.argv[0])[0] or '.'
        tsidb_path = os.path.join(mod_dir, 'tsi.db');
        #print tsidb_path
        
        # process none english data
        ar = array.array('c', doc);
        idx =  0
        while idx < len(ar):
            if ar[idx]>='\xa0': 
                ar[idx]=' '
                idx=idx+1
                ar[idx]=' '
            idx=idx+1
        ec = split(ar.tostring(), ' ')
        ec = filter(lambda x: x != 'EOS' and x != '', ec)
        etext = lower( join(ec, ' ') )
        #print 'etext:'+etext
        
        if stop_syn is None:
            self.stop_syn = {}
        else:
            self.stop_syn = stop_syn
        self.encoding = encoding
        
        csplitter_lock.acquire() # lib is not thread-safe
        c=split(tabelib.sparse_tostr(doc, tsidb_path), ' ');
        csplitter_lock.release()
        
        c=filter(lambda x: x != 'EOS' and x != '', c)
        text=join(c, ' ')
        #print 'ctext:'+text
        BaseSplitter.__init__(self, text+' '+etext, self.stop_syn)
